/*******************************************************************************
 * Copyright (c) 2010 Attila Kovacs <attila_kovacs@post.harvard.edu>.
 * All rights reserved. 
 * 
 * This file is part of crush.
 * 
 *     crush is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     crush is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with crush.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Contributors:
 *     Attila Kovacs <attila_kovacs@post.harvard.edu> - initial API and implementation
 ******************************************************************************/
package test;

import java.util.Arrays;

import util.*;



public class FFTTest {

	public static void main(String[] args) {
		
		double[] data = new double[16];
		
		data[0] = 1.0;
		Complex[] spectrum = ArrayUtil.FFT(data);
		System.out.println("delta[0]:");
		print(spectrum);
		
		
		Arrays.fill(data, 1.0);
		spectrum = ArrayUtil.FFT(data);
		System.out.println("cons(1.0):");
		print(spectrum);
		
		
		for(int i=0; i<data.length; i++) data[i] = Math.cos(2.0 * Math.PI * i / data.length);
		spectrum = ArrayUtil.FFT(data);
		System.out.println("cos1:");
		print(spectrum);
		
		for(int i=0; i<data.length; i++) data[i] = Math.sin(4.0 * Math.PI * i / data.length);
		spectrum = ArrayUtil.FFT(data);
		System.out.println("sin2:");
		print(spectrum);		
		
		int n = Integer.parseInt(args[0]);
		data = new double[n*1024*1024];
		for(int i=0; i<data.length; i++) data[i] = Math.random();
		long time = -System.currentTimeMillis();
		ArrayUtil.inplaceFFT(data, true);
		time += System.currentTimeMillis();
		System.err.println("real transform of " + n + "M points: " + time + "ms");
		
		
		Complex[] cdata = new Complex[data.length >> 1];
		for(int i=0; i<cdata.length; i++) cdata[i] = new Complex(Math.random(), Math.random());
		time = -System.currentTimeMillis();
		ArrayUtil.FFT(cdata, true);
		time += System.currentTimeMillis();
		System.err.println("complex transform of " + n + "M points: " + time + "ms");
		
		
		
	}

	public static void print(Complex[] data) {
		for(int i=0; i<data.length; i++) 
			System.out.println("  " + i + ":\t" + data[i].toString(Util.f6));
		System.out.println();
	}
	
}
